using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;
using UnityEngine;
using UnityEngine.SceneManagement;

public class Timer : MonoBehaviour
{
    public float chronometre;
    public bool countDownOn = true;
    public GameObject countTimerHUD;
    public movePlayer player;
    public bool ActivatedOnStart = false;

    public AudioClip TimerStartAudio;
    private AudioSource TimerStartAudioSource;
    private bool flagFinPartie = false;

    void Start()
    {
        countTimerHUD.SetActive(false);

        TimerStartAudioSource = gameObject.AddComponent<AudioSource>();
        TimerStartAudioSource.clip = TimerStartAudio;
        TimerStartAudioSource.loop = false;
        TimerStartAudioSource.playOnAwake = false;
        TimerStartAudioSource.volume = 1f;

        if (ActivatedOnStart) EnableTimer();
        //StartCoroutine(timer());
    }
    private void Update()
    {
        if(chronometre < 20)
        {
            countTimerHUD.GetComponent<Text>().color = Color.yellow;
            if(chronometre < 10)
            {
                countTimerHUD.GetComponent<Text>().color = Color.red;
                if(chronometre == 0 && !flagFinPartie)
                {
                    flagFinPartie = true;
                    StartCoroutine(finDePartieTiming());
                }
            }
        }
    }

    public void EnableTimer()
    {
        if (!countTimerHUD.activeSelf)
        {
            countTimerHUD.SetActive(true);
            TimerStartAudioSource.Play();
            countTimerHUD.GetComponent<Animation>().Play("TimerShow");
            StartCoroutine(timer());
        } else
        {
            Debug.Log("Le timer est dj activ!");
        }
        
    }

    private IEnumerator timer()
    {
        while (chronometre > 0)
        {
            chronometre--;
            yield return new WaitForSeconds(1f);
            countTimerHUD.GetComponent<Text>().text = string.Format("{0:0}:{1:00}",Mathf.Floor(chronometre/60),chronometre%60);

        }
    }
    private IEnumerator finDePartieTiming()
    {
        yield return new WaitForSeconds(2f);
        player.finDePartie();
    }
}
