using System.Collections;
using System.Collections.Generic;
using UnityEngine.Tilemaps;
using UnityEngine;

public class BoosterItems : MonoBehaviour
{
    public movePlayer player;
    public SpriteRenderer spriteRenderer;

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.CompareTag("Obstacle"))
        {
            StartCoroutine(slowFiveSecond());
        }
        else if (collision.CompareTag("Booster"))
        {
            StartCoroutine(boostFiveSecond());
        }
        else if (collision.CompareTag("rageBoost"))
        {
            StartCoroutine(rageTenSecond());
        }
        else if (collision.CompareTag("Destructible") & player.isRage == true)
        {
            Destroy(collision.gameObject);

            
        }else if(collision.CompareTag("Destructible") & player.isRage == false)
        {
            player.transform.position = player.transform.position + Vector3.down;
        }
        else if (collision.CompareTag("Teleporteur") & player.canTeleport == true)
        {
            Debug.LogWarning("TELEPORTEUR");
            Transform teleportDest = collision.gameObject.GetComponent<teleportScripte>().teleportDestination.transform;
            eventTeleport(teleportDest);
            StartCoroutine(teleportDelay());
        }
    }

    // Les Coroutines ------------------------------------
    public IEnumerator slowFiveSecond()
    {
        player.isSlow = true;
        yield return new WaitForSeconds(4.7f);
        player.isSlow = false;

    }
    public IEnumerator boostFiveSecond()
    {
        player.isBoost = true;

        yield return new WaitForSeconds(4.7f);

        player.isBoost = false;
    }

    public IEnumerator rageTenSecond()
    {
        player.isRage = true;
        spriteRenderer.color = Color.HSVToRGB(0, 52, 88);

        yield return new WaitForSeconds(9.7f);

        player.isRage = false;
        spriteRenderer.color = Color.white;

    }

    public IEnumerator teleportDelay()
    {
        player.canTeleport = false;
        yield return new WaitForSeconds(4.7f);
        player.canTeleport = true;
    }
    //-------------------------------------------------
    public void eventTeleport(Transform _transform)
    {
        Vector3 droite = new Vector3(1,0,0);
        player.transform.position = _transform.transform.position+droite;
    }

}
