using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class backgroundAmbiance : MonoBehaviour
{
    public AudioClip[] Annonces;
    public float WaitTime;
    public float volume;
    private AudioSource AnnoncesAudioSource;
    private int lastAnnonce;
    private int currentAnnonce;
    private bool askForNextAnnonce;

    // Start is called before the first frame update
    void Start()
    {
        lastAnnonce = Random.Range(0, Annonces.Length);
        AnnoncesAudioSource = gameObject.AddComponent<AudioSource>();
        AnnoncesAudioSource.clip = Annonces[lastAnnonce];
        AnnoncesAudioSource.loop = false;
        AnnoncesAudioSource.volume = volume;
        AnnoncesAudioSource.Play();
    }

    // Update is called once per frame
    void Update()
    {
        if(!AnnoncesAudioSource.isPlaying && !askForNextAnnonce)
        {
            askForNextAnnonce = true;
            StartCoroutine(PlayAnnonce());
        }
    }
    
    IEnumerator PlayAnnonce()
    {
        yield return new WaitForSeconds(WaitTime);
        currentAnnonce = Random.Range(0, Annonces.Length);
        while (currentAnnonce == lastAnnonce) currentAnnonce = Random.Range(0, Annonces.Length);
        AnnoncesAudioSource.clip = Annonces[currentAnnonce];

        AnnoncesAudioSource.Play();
        askForNextAnnonce = false;
    }
}
