﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.EventSystems;
using UnityEngine.SceneManagement;

public class ButtonsSpritesActions : MonoBehaviour, IPointerDownHandler
{
    // Paramètres à définir dans Unity
    public Sprite ActionSprite;
    public Canvas DestCanva;
    public AudioClip ClickSound;
    public int buttonType;
    public int TeleportToScene;

    private GameObject ActionSpriteGameObject;
    private SpriteRenderer ActionSpriteRenderer;
    private AudioSource ClickSoundAudioSource;

    private int SortingOrder;

    public GameObject Camera;

    // Start is called before the first frame update
    void Start()
    {
        Button btn = GetComponent<Button>();
        btn.onClick.AddListener(TaskOnClick);
        SortingOrder = DestCanva.sortingOrder-1;
        ClickSoundAudioSource = gameObject.AddComponent<AudioSource>();
        ClickSoundAudioSource.clip = ClickSound;
        ClickSoundAudioSource.loop = false;
        ClickSoundAudioSource.volume = 1f;
    }
    public void OnPointerDown(PointerEventData data)
    {
        ActionSpriteGameObject = new GameObject("ButtonActionSprite"); // Je créé un objet nommé start-mask
        ActionSpriteGameObject.transform.position = transform.position;
        ActionSpriteGameObject.transform.localScale = new Vector2(transform.localScale.x * (12 / transform.localScale.x), transform.localScale.y * (12 / transform.localScale.y));
        ActionSpriteRenderer = ActionSpriteGameObject.AddComponent<SpriteRenderer>(); //J'ajoute un composant SpriteRenderer (un sprite en gros)
        ActionSpriteRenderer.sprite = ActionSprite; //Je lui attribue la texture qu'on a défini plus haut (définie sur l'interface d'unity)
        ActionSpriteRenderer.sortingOrder = SortingOrder; //Je la met au premier plan
        ClickSoundAudioSource.Play();
    }

    void TaskOnClick()
    {
        Destroy(ActionSpriteGameObject);
        if (buttonType == 0)
        {
            //SceneManager.LoadScene(TeleportToScene);
            Camera.GetComponent<MenuInit>().LoadScene(TeleportToScene);
        } else if (buttonType == 1) SceneManager.LoadScene(TeleportToScene);
    }
}
