﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class MenuInit : MonoBehaviour
{
    AudioSource m_MyAudioSource;

    //Play the music
    bool m_Play;
    private int track;
    public AudioClip MenuMusicClip;
    public float IntroSpriteZoomSpeed = 10f;

    //Image overlay
    public Sprite MenuStartMaskSprite;
    private GameObject MenuStartMask;
    private SpriteRenderer MenuStartMaskRenderer;
    private bool MenuStarMaskDestroyed;

    // Autres Variables
    private int TeleportToScene;
    public GameObject BlackScreenGO;


    // Start is called before the first frame update
    void Start()
    {   
        // Pour la musique

        //Fetch the AudioSource from the GameObject
        m_MyAudioSource = GetComponent<AudioSource>();
        //Ensure the toggle is set to true for the music to play at start-up
        m_Play = true;
        m_MyAudioSource.loop = false;
        m_MyAudioSource.volume = 1f;
        //Musique 0
        track = 0;

        // Pour le sprite de début
        MenuStartMask = new GameObject("start-mask"); // Je créé un objet nommé start-mask
        MenuStartMaskRenderer = MenuStartMask.AddComponent<SpriteRenderer>(); //J'ajoute un composant SpriteRenderer (un sprite en gros)
        MenuStartMaskRenderer.sprite = MenuStartMaskSprite; //Je lui attribue la texture qu'on a défini plus haut (définie sur l'interface d'unity)
        MenuStartMaskRenderer.sortingOrder = 10; //Je la met au premier plan
        MenuStartMask.AddComponent<FullscreenSprite>(); //J'applique le script qui la met en fullscreen
        MenuStarMaskDestroyed = false;

        BlackScreenGO.SetActive(false);
    }

    // Update is called once per frame
    void Update()
    {
        if(m_Play == true && !m_MyAudioSource.isPlaying && track==0) {
            m_MyAudioSource.Play();
            track = 1;
        }else if(m_Play == true && !m_MyAudioSource.isPlaying && track == 1) {
            m_MyAudioSource.clip = MenuMusicClip;
            m_MyAudioSource.loop = true;
            m_MyAudioSource.volume = 0.25f;
            m_MyAudioSource.Play();
        }
        if (MenuStarMaskDestroyed == false)
        {
            if (MenuStartMask.transform.localScale.x < 40f)
            {
                MenuStartMask.transform.localScale = new Vector2(MenuStartMask.transform.localScale.x + IntroSpriteZoomSpeed * Time.deltaTime, MenuStartMask.transform.localScale.y + IntroSpriteZoomSpeed * Time.deltaTime);
            }
            else
            {
                Destroy(MenuStartMask);
                MenuStarMaskDestroyed = true;
            }
        }
        
    }

    public void LoadScene(int scene)
    {
        TeleportToScene = scene;
        StartCoroutine(chargerSceneArrierePlan());
    }

    IEnumerator chargerSceneArrierePlan()
    {
        BlackScreenGO.SetActive(true);
        GetComponent<AudioLiscenerControl>().MuteAllSound();
        AsyncOperation asyncLoad = SceneManager.LoadSceneAsync(TeleportToScene);

        while (!asyncLoad.isDone)
        {
            yield return null;
        }
    }
}
