using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using UnityEngine.SceneManagement;

public class movePlayer : MonoBehaviour
{
   int nblifes = 1;
    Rigidbody2D rabitRidgedbody2D;
    // Joystick
    public FloatingJoystick floatingJoystick;

    // Variable de base pour le mouvement
    public float refMoveSpeed;
    private float moveSpeed;
    Vector3 velocity = Vector3.zero;
    float horizontalMovement;
    float verticalMovement;

    

    public float multiplierOverFullSpeed = 5f; // En seconde

    public Text debugTxt;

    // Variables compl�mentaire pour la rotation du joueur (avec le script non abouti)
    private Vector2 inertie = new Vector2(0, 0);
    private float vertical;
    private float horizontal;
    private float inverse;
    private float fps;
    private float rotate;
    private float targetRotation;
    private float localRotation;

    // Variable boosters et autres
    public bool isSlow, isBoost, isRage, canDestroy;
    public bool canTeleport = true;

    private int songState;

    //Variables pour le son de mouvement
    public AudioClip[] MovingSound;
    public float WaitTime;
    public float volume;
    private AudioSource MovingSoundAudioSource;

    // Autres Variables
    public GameObject BlackScreenGO;
    public GameObject Camera;

    void Start()
    {
        moveSpeed = refMoveSpeed;
        localRotation = transform.localEulerAngles.z;

        // Son de mouvement
        MovingSoundAudioSource = gameObject.AddComponent<AudioSource>();
        MovingSoundAudioSource.clip = MovingSound[0];
        MovingSoundAudioSource.loop = true;
        MovingSoundAudioSource.volume = volume;
        MovingSoundAudioSource.Play();

        BlackScreenGO.SetActive(false);
    }

    private void Update()
    {
        // Vertical et Horizontal sont les variables qui correspondent au joystick directionnel

        if (isSlow == true)
        {
            if (songState == 0)
            {
                StartCoroutine(slow5Secondes());
                MovingSoundAudioSource.Stop();
                MovingSoundAudioSource.clip = MovingSound[1];
                MovingSoundAudioSource.Play();
            }
        }else if (isBoost == true)
        {
            if (songState == 0)
            {
                StartCoroutine(boost5Secondes());
                MovingSoundAudioSource.Stop();
                MovingSoundAudioSource.loop = false;
                MovingSoundAudioSource.clip = MovingSound[2];
                MovingSoundAudioSource.Play();
                songState = 1;
            }
            else if (songState == 1)
            {
                if (!MovingSoundAudioSource.isPlaying)
                {
                    songState = 2;
                    MovingSoundAudioSource.Stop();
                    MovingSoundAudioSource.loop = true;
                    MovingSoundAudioSource.clip = MovingSound[0];
                    MovingSoundAudioSource.Play();
                }
            }
        }
        else if(isRage == true)
        {
            StartCoroutine(rage10Secondes());
        }

        vertical = Input.GetAxis("Vertical") + floatingJoystick.Vertical;
        horizontal = Input.GetAxis("Horizontal") + floatingJoystick.Horizontal;

        if (vertical != 0)
        {
            if (inertie.y <= 1 && inertie.y >= -1) inertie.y = Mathf.Lerp(inertie.y, 1 * vertical, multiplierOverFullSpeed * Time.deltaTime);
            else
            {
                if (inertie.y > 1)
                {
                    inertie.y = 1;
                }
                else if (inertie.y < -1)
                {
                    inertie.y = -1;
                }
            }
        }
        else
        {
            if (inertie.y != 0) inertie.y = Mathf.Lerp(inertie.y, 0, multiplierOverFullSpeed * Time.deltaTime); // Cap at some min value too
        }

        if (horizontal != 0)
        {
            if (inertie.x <= 1 && inertie.x >= -1) inertie.x = Mathf.Lerp(inertie.x, 1 * horizontal, multiplierOverFullSpeed * Time.deltaTime);
            else
            {
                if (inertie.x > 1)
                {
                    inertie.x = 1;
                }
                else if (inertie.x < -1)
                {
                    inertie.x = -1;
                }
            }
        }
        else
        {
            if (inertie.x != 0) inertie.x = Mathf.Lerp(inertie.x, 0, multiplierOverFullSpeed * Time.deltaTime); // Cap at some min value too
        }

        horizontalMovement = (moveSpeed * inertie.x);
        verticalMovement = moveSpeed * inertie.y;

        // Ce code n'est pas abouti
        /*
         * 
        if (vertical >= 0) inverse = 0;
        else inverse = 180;

        localRotation = transform.localEulerAngles.z;
        localRotation = (localRotation > 180) ? localRotation - 360 : localRotation;

        if (vertical != 0 || horizontal != 0)
        {
            rotate = (inverse - (Mathf.Sign(vertical) * Mathf.Asin(horizontal) * Mathf.Rad2Deg));
            //transform.localEulerAngles = new Vector3(0.0f, 0.0f, (inverse - (Mathf.Sign(vertical) * Mathf.Asin(horizontal) * Mathf.Rad2Deg)));
            
            if (Mathf.Round(localRotation) != Mathf.Round(rotate))
            {
                
                if (transform.localEulerAngles.z < rotate)
                {
                    targetRotation = targetRotation + 1;
                }
                else
                {
                    targetRotation = targetRotation - 1;
                }
                transform.localEulerAngles = new Vector3(0.0f, 0.0f, targetRotation);
            }
            
        }
        */


        if (vertical > 0) transform.localEulerAngles = new Vector3(0.0f, 0.0f, -1 * Mathf.Asin(horizontal) * Mathf.Rad2Deg);
        else if (vertical == 0 && horizontal == 0) transform.localEulerAngles = new Vector3(0.0f, 0.0f, 0.0f);
        else transform.localEulerAngles = new Vector3(0.0f, 0.0f, 180 - (-1 * Mathf.Asin(horizontal) * Mathf.Rad2Deg));


        fps = 1.0f / Time.deltaTime;

        // Son de mouvement
        MovingSoundAudioSource.volume = volume * (Mathf.Abs(horizontal) + Mathf.Abs(vertical));
        
        
    }
    private void FixedUpdate()
    {
        if (debugTxt != null)
        {
            debugTxt.text = "FPS: " + fps + "\nxInput: " + horizontal + "\nyInput: " + vertical + "\nRotate: " + transform.localEulerAngles.z + "\nCalc(son):" + (Mathf.Abs(horizontal) + Mathf.Abs(vertical)) + "\nmoveSpeed:" + moveSpeed;
        }
        Vector3 dirHonrizontal = new Vector2(horizontalMovement, verticalMovement);
        transform.Translate(dirHonrizontal, Space.World);
    }


    // Les boosters ---------------------------------
    public IEnumerator slow5Secondes()
    {
        songState = 1;
        moveSpeed = refMoveSpeed * 0.5f;
        yield return new WaitForSeconds(5f);

        moveSpeed = refMoveSpeed;
        MovingSoundAudioSource.Stop();
        MovingSoundAudioSource.clip = MovingSound[0];
        MovingSoundAudioSource.Play();
        isSlow = false;
        songState = 0;
    }

    public IEnumerator boost5Secondes()
    {
        songState = 1;
        moveSpeed = refMoveSpeed * 1.5f;
        yield return new WaitForSeconds(5f);
        moveSpeed = refMoveSpeed;
        isBoost = false;
        songState = 0;
    }

    public IEnumerator rage10Secondes()
    {
        moveSpeed = refMoveSpeed * 1.5f;
        canDestroy = true;
        yield return new WaitForSeconds(10f);
        canDestroy = false;
        moveSpeed = refMoveSpeed;
    }

    public void finDePartie()
    {
        StartCoroutine(chargerSceneArrierePlan());
        //SceneManager.LoadScene("EcranFinPartie");
        //Debug.Log("Fin de partie");
    }
    IEnumerator chargerSceneArrierePlan()
    {
        BlackScreenGO.SetActive(true);
        Camera.GetComponent<AudioLiscenerControl>().MuteAllSound();
        yield return new WaitForSeconds(2);
        AsyncOperation asyncLoad = SceneManager.LoadSceneAsync("EcranFinPartie");

        while (!asyncLoad.isDone)
        {
            yield return null;
        }
    }


    //Ajouté par Lazar
    float velocityVsUp = 0;
    
    float steerinput = 0;
    float accelerationInput = 0;
    public void SetInputVector(Vector2 inputVector)
    {
        steerinput = inputVector.x;
        accelerationInput = inputVector.y;
    }

    float GetLateralVelocity()
{
    return Vector2.Dot(transform.right , rabitRidgedbody2D.velocity);
}

public bool IsTireScreeching(out float lateralVelocity , out bool isBreaking)
   {
      velocityVsUp = Vector2.Dot(transform.up , rabitRidgedbody2D.velocity);
      lateralVelocity = GetLateralVelocity();
      isBreaking = false;

      if(accelerationInput < 0 && velocityVsUp > 0 )
      {
          isBreaking = true;
          return true;
      }

      if(Mathf.Abs(GetLateralVelocity()) > 1.0f)
      {
          return true;
      }
      
      
      return false;
   }


   // Partie Enemie
  
   
     

 



}